//
// Created by Иван_Архипов on 24.11.2017.
//

#ifndef LOTRO_DAT_LIBRARY_WAVSUBFILE_H
#define LOTRO_DAT_LIBRARY_WAVSUBFILE_H

#include "SubFile.h"

namespace LOTRO_DAT {
    class WavSubFile : public SubFile {
    public:
        WavSubFile() = delete;
        explicit WavSubFile(const WavSubFile &other) = delete;
        WavSubFile &operator =(const WavSubFile &other) = delete;

        WavSubFile(DatFile &dat, long long dictionary_offset, long long fragments_count, long long unknown1,
                   long long file_id, long long file_offset, long long file_size, long long timestamp,
                   long long version, long long block_size);


        FILE_TYPE FileType() const override;

        std::string Extension() const override;

        SubfileData PrepareForExport(const BinaryData &file_data) override;

        BinaryData MakeForImport(const BinaryData &old_data, const SubfileData &data) override;

    };
};


#endif //LOTRO_DAT_LIBRARY_WAVSUBFILE_H
